<?php
if (!defined("PHPUnit_MAIN_METHOD")) {
    define("PHPUnit_MAIN_METHOD", "Science_Astronomy_JDTest::main");
}

require_once "Science/Astronomy.php";
	
class Science_Astronomy_JDTest extends PHPUnit_Framework_TestCase {
    var $handle;
	
    function main()
    {
        require_once "PHPUnit/TextUI/TestRunner.php";

        PHPUnit_TextUI_TestRunner::run(
            new PHPUnit_Framework_TestSuite("Science_Astronomy_JDTest")
        );
    }

    function setUp()
    {
        $this->handle = new Science_Astronomy();
    }

    function testJD()
    {
        $tests = array(
            0 => array(
                "year"   => 2000,
                "month"  =>    1,
                "day"    =>    1,
                "hour"   =>   12,
                "minute" =>    0,
                "second" =>    0
            ),
            1 => array(
                "year"   => 2007,
                "month"  =>    1,
                "day"    =>   14,
                "hour"   =>   13,
                "minute" =>   18,
                "second" =>   59.9
            ),
            2 => array(
                "year"   => 2132,
                "month"  =>    8,
                "day"    =>   31,
                "hour"   =>   12,
                "minute" =>    0,
                "second" =>    0
            ),
            3 => array(
                "year"   => -4712,
                "month"  =>     1,
                "day"    =>     1,
                "hour"   =>    12,
                "minute" =>     0,
                "second" =>     0
            )
        );
        
        $results = array(
            0 => array(
                "JD"       =>   2451545.0
            ),
            1 => array(
                "JD"       =>   2454115.05486
            ),
            2 => array(
                "JD"       =>   2500000.0
            ),
            3 => array(
                "JD"       =>         0
            )
        );
        
        for ($i = 0; $i < sizeof($tests); $i++) {
            $JD = $this->handle->dateToJD($tests[$i]["year"], $tests[$i]["month"], $tests[$i]["day"], $tests[$i]["hour"], $tests[$i]["minute"], $tests[$i]["second"]);
            $JD = round($JD, 5);
            
            $this->assertEquals($results[$i]["JD"], $JD);
        }
    }
}

if (PHPUnit_MAIN_METHOD == 'Science_Astronomy_Test::main') {
    Science_Astronomy_JDTest::main();
}
?>
