<?php
if (!defined("PHPUnit_MAIN_METHOD")) {
    define("PHPUnit_MAIN_METHOD", "Science_Astronomy_MSTTest::main");
}

require_once "Science/Astronomy.php";
	
class Science_Astronomy_MSTTest extends PHPUnit_Framework_TestCase {
    var $handle;
	
    function main()
    {
        require_once "PHPUnit/TextUI/TestRunner.php";

        PHPUnit_TextUI_TestRunner::run(
            new PHPUnit_Framework_TestSuite("Science_Astronomy_MSTTest")
        );
    }

    function setUp()
    {
        $this->handle = new Science_Astronomy();
    }

    function testJD()
    {
        $tests = array(
            0 => array(
                "year"      => 2006,
                "month"     =>   12,
                "day"       =>    1,
                "hour"      =>   23,
                "minute"    =>    0,
                "second"    =>    0,
                "timezone"  =>    1,
                "longitude" =>    5
            ),
            1 => array(
                "year"      => 2011,
                "month"     =>    3,
                "day"       =>    1,
                "hour"      =>   18,
                "minute"    =>   20,
                "second"    =>    0,
                "timezone"  =>   -5,
                "longitude" =>  -70
            ),
            2 => array(
                "year"      => 2000,
                "month"     =>    3,
                "day"       =>    6,
                "hour"      =>   22,
                "minute"    =>    0,
                "second"    =>    0,
                "timezone"  =>    1,
                "longitude" =>   13.4
            )
        );
        
        $results = array(
            0 => array(
                "MST"      =>   45.616554
            ),
            1 => array(
                "MST"      =>   79.410380
            ),
            2 => array(
                "MST"      =>  133.297315
            )
        );
        
        for ($i = 0; $i < sizeof($tests); $i++) {
            $JD = $this->handle->dateToJD($tests[$i]["year"], $tests[$i]["month"], $tests[$i]["day"], $tests[$i]["hour"], $tests[$i]["minute"], $tests[$i]["second"]);
            $MST = $this->handle->meanSiderealTime($JD, $tests[$i]["timezone"], $tests[$i]["longitude"]);
            $MST = round($MST, 6);
            
            $this->assertEquals($results[$i]["MST"], $MST);
        }
    }
}

if (PHPUnit_MAIN_METHOD == 'Science_Astronomy_Test::main') {
    Science_Astronomy_MSTTest::main();
}
?>
