<?php
if (!defined("PHPUnit_MAIN_METHOD")) {
    define("PHPUnit_MAIN_METHOD", "Science_Astronomy_MoonPhaseTest::main");
}

require_once "Science/Astronomy.php";
	
class Science_Astronomy_MoonPhaseTest extends PHPUnit_Framework_TestCase {
    var $handle;
	
    function main()
    {
        require_once "PHPUnit/TextUI/TestRunner.php";

        PHPUnit_TextUI_TestRunner::run(
            new PHPUnit_Framework_TestSuite("Science_Astronomy_MoonPhaseTest")
        );
    }

    function setUp()
    {
        $this->handle = new Science_Astronomy();
    }

    function testMoonPhase()
    {
        $tests = array(
            0 => array(
                "timestamp" => mktime( 8, 31, 40,  8,  2, 2011, 1),
            ),
            1 => array(
                "timestamp" => mktime( 0,  0,  0,  1,  3, 2000, 0),
            ),
            2 => array(
                "timestamp" => mktime( 12,  0,  0, 12, 23, 1999, 0),
            )
        );
        
        $results = array(
            0 => array(
                "age"       =>   2.8811,
                "distance"  =>  57.4268,
                "latitude"  =>  -5.0742,
                "longitude" => 164.0474,
                "phase"     => "Waxing Crescent",
                "zodiac"    => "Leo"
            ),
            1 => array(
                "age"       =>  25.9306,
                "distance"  =>  63.6441,
                "latitude"  =>   4.708 ,
                "longitude" => 240.5892,
                "phase"     => "Waning Crescent",
                "zodiac"    => "Libra"
            ),
            2 => array(
                "age"       =>  15.4306,
                "distance"  =>  56.1763,
                "latitude"  =>  -2.2594,
                "longitude" => 101.1845,
                "phase"     => "Full",
                "zodiac"    => "Gemini"
            )
        );
        
        for ($i = 0; $i < sizeof($tests); $i++) {
            $phase = $this->handle->calculateMoonPhase($tests[$i]["timestamp"]);
        
            $this->assertEquals($results[$i], $phase);
        }
    }
}

if (PHPUnit_MAIN_METHOD == 'Science_Astronomy_Test::main') {
    Science_Astronomy_MoonPhaseTest::main();
}
?>
