<?php
if (!defined("PHPUnit_MAIN_METHOD")) {
    define("PHPUnit_MAIN_METHOD", "Science_Astronomy_MoonRiseSetTest::main");
}

require_once "Science/Astronomy.php";
	
class Science_Astronomy_MoonRiseSetTest extends PHPUnit_Framework_TestCase {
    var $handle;
	
    function main()
    {
        require_once "PHPUnit/TextUI/TestRunner.php";

        PHPUnit_TextUI_TestRunner::run(
            new PHPUnit_Framework_TestSuite("Science_Astronomy_MoonRiseSetTest")
        );
    }

    function setUp()
    {
        $this->handle = new Science_Astronomy();
    }

    function testMoonRiseSet()
    {
        $tests = array(
            0 => array(
                "latitude"  =>  51.3000,
                "longitude" =>   6.7667,
                "timestamp" =>  mktime( 8, 31, 40,  8,  2, 2011, 1),
                "timezone"  =>   2
            ),
            1 => array(
                "latitude"  =>  68.43,
                "longitude" =>  17.42,
                "timestamp" =>  mktime( 0,  0,  0,  1,  3, 2000, 0),
                "timezone"  =>   1
            ),
            2 => array(
                "latitude"  =>  67.43,
                "longitude" =>   0,
                "timestamp" =>  mktime( 0,  0,  0, 12, 25, 1999, 0),
                "timezone"  =>   0
            )
        );
        
        $results = array(
            0 => array(
                "rise"    => array("time" => "09:38", "azi" =>  87.5299),
                "set"     => array("time" => "22:03", "azi" => 267.6256),
                "message" => ""
            ),
            1 => array(
                "rise"    => array("time" => "06:28", "azi" => 140.7293),
                "set"     => array("time" => "11:59", "azi" => 216.7634),
                "message" => ""
            ),
            2 => array(
                "rise"    => array("time" => "17:46", "azi" =>  39.9606),
                "set"     => array("time" => "12:06", "azi" => 322.7386),
                "message" => ""
            )
        );
        
        for ($i = 0; $i < sizeof($tests); $i++) {
            $moon = $this->handle->calculateMoonRiseSet($tests[$i]["timestamp"], SCIENCE_ASTRONOMY_RET_STRING, $tests[$i]["latitude"], $tests[$i]["longitude"], $tests[$i]["timezone"]);
        
            $this->assertEquals($results[$i], $moon);
        }
    }
}

if (PHPUnit_MAIN_METHOD == 'Science_Astronomy_Test::main') {
    Science_Astronomy_MoonRiseSetTest::main();
}
?>
